#!/usr/bin/env python3


class Complex(object):
    def __init__(self, re, im=0.0):
       self.re = re
       self.im = im

    def __add__(self, b):
       return Complex(self.re + b.re, self.im + b.im)
    
    def __iadd__(self, b):
       self.re += b.re
       self.im += b.im
       return self

    def __sub__(self, b):
       return Complex(self.re - b.re, self.im - b.im)

    def __mul__(self, b):
       return Complex(self.re * b.re + self.im * b.im, self.re * b.im + self.im * b.re)


    def __abs__(self):
       return ((self.re * self.re) + (self.im * self.im)) ** 0.5



################################################################################


a = Complex(1.0, 2.0)
b = Complex(1.0)

a + b    # a.__add__(b)
   
(a + b) + c


x = abs(a)


a += b  # a.__iadd__(b)
