#!/usr/bin/env python3


class ODict(dict):
    def __init__(self):
        super().__init__()
        self._keys = []

    def __setitem__(self, key, value):
        if key not in self:
            self._keys.append(key)
        super().__setitem__(key, value)

    def __delitem__(self, key):
        super().__delitem__(key)
        self._keys.remove(key)
        
    def __iter__(self):
        return self._keys
        
        

class MyClass:




################################################################################


od = ODict()

od['a'] = 10
