#!/usr/bin/env python3


class MyRangeIterator(object):
    def __init__(self, stop):
        self.stop = stop
        self.current = 0

    def __next__(self):
        if self.current >= self.stop:
            raise StopIteration()
        c = self.current
        self.current += 1
        return c

class MyRange(object):
    def __init__(self, stop):
        self.stop = stop

    def __iter__(self):
        return MyRangeIterator(self.stop)

    def __getitem__(self, index):
        return index


################################################################################


r = MyRange(10)


for i in r:
    print(i)

print(list(MyRange(8)))

print(r[2])

